/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package repasopoocoches.Abstracciones;

/**
 *
 * @author kyman
 */
public abstract class Coche implements repasopoocoches.Interfaces.Coches {
    
    protected String marca = "Desconocido";
    protected String modelo = "Desconocido";
    public float potencia = 0;
    protected float velocidad = 0;
    protected float velocidad_maxima = 0;
    protected float combustible = 0;
    protected float capacidad_del_tanque = 0;
    
    protected void ejecutar_aceleracion(float unidades){
        
        float incremento = unidades * potencia;
        
        if(incremento > 0){
            if(velocidad < velocidad_maxima && (velocidad += incremento) > velocidad_maxima)
                velocidad = velocidad_maxima;
        }else if(velocidad != 0 && (velocidad -= incremento) < 0)
            velocidad = 0;
        
    }
    
    protected float meter_combustible(float cantidad){
        
        if(combustible < capacidad_del_tanque){
            if((combustible += cantidad) > capacidad_del_tanque){
                cantidad = combustible - capacidad_del_tanque;
                combustible = capacidad_del_tanque;
            }else 
                cantidad = 0;
        }
        
        return cantidad;
    }
    
    @Override
    public String toString(){
        return (
            "Coche es el modelo '" + modelo + "' de la marca '" + marca + "' con " + potencia + " de caballos de potencia.\n" + 
            "Circula a una velocidad de " + velocidad + "km/h de " + velocidad_maxima + "km/h de velocidad máxima.\n" + 
            "Tiene " + combustible + "l de combustible de un máximo de " + capacidad_del_tanque + " litros."
        );
    }
    
}
