/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package repasopoocoches;

import java.util.ArrayList;
import java.util.Arrays;
import repasopoocoches.Abstracciones.Coche;
import repasopoocoches.Marcas.Ford;
import repasopoocoches.Marcas.Peugeut;
import repasopoocoches.Marcas.Renault;
import repasopoocoches.Marcas.Toyota;

/**
 *
 * @author kyman
 */
public class RepasoPOOCoches {
    
    // Configuracion.
    private static final Coche[] coches = {
        new Ford("Mustang", 1.3f),
        new Renault("Sedan", .8f), 
        new Renault("Clio", 2.5f), 
        new Toyota("Corola", 1.2f), 
        new Peugeut("207", 2.5f)
    };
    // Configuracion.

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        ArrayList<Coche> coches = new ArrayList<>(Arrays.asList(RepasoPOOCoches.coches));
        
        coches.sort((Object coche_a, Object coche_b) -> (int)(
            ((Coche)coche_a).potencia * Math.pow(10, 8) - ((Coche)coche_b).potencia * Math.pow(10, 8)
        ));
        
        for(int i = 0, l = coches.size(); i < l; i ++){
            
            Coche coche = coches.get(i);
            
            coche.acelerar();
            coche.frenar();
            coche.repostar();
            
            System.out.println("\n" + coche + "\n");
            
        }
        
    }
    
}
